
#include "vce.h"
#include <windows.h>
#include "announce.h"
#include "obj.h"
#include "resource.h"
#include "main.h"
#include "win.h"
#include "net.h"
#include "msg.h"
#include "msgdlg.h"

void announce_dialog_close( HWND hwnd)
{

    DestroyWindow( hwnd);
    msgdlg_free_one( hwnd);
}
    
LRESULT CALLBACK announce_dlg_proc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    switch( msg) {
    case WM_INITDIALOG:
        return FALSE;
    case WM_COMMAND:
        switch( LOWORD( wp)) {
        case IDOK:
        {
            char buff[256];
            char pass[256];
            GetWindowText( GetDlgItem( hwnd, IDC_EDIT_PASSWORD),
                           pass, sizeof( pass));
            GetWindowText( GetDlgItem( hwnd, IDC_EDITMSG), buff, sizeof( buff));
            net_announce( pass, buff);
            announce_dialog_close( hwnd);
        }
        break;
        case IDCANCEL:
            announce_dialog_close( hwnd);
            break;
        }
        break;
    case WM_CLOSE:
        announce_dialog_close( hwnd);
        break;
    default:
        return FALSE;        
    }
    return TRUE;
}
/* -------------------------------------------------------------------------
 * create sendmessage dialog
 * -------------------------------------------------------------------------*/
int announce_create_dialog( void)
{
    msg_dlg_t *s;
    
    s = (msg_dlg_t *)vce_alloc_array_object( msg_dlg_mi);
    if( s == NULL) return -1;
    
    s->hwnd = CreateDialog(
        hInst, MAKEINTRESOURCE( IDD_ANNOUNCE),
        hWnd,(DLGPROC)announce_dlg_proc);
    
    ShowWindow( s->hwnd, SW_SHOW);
    return 0;
}
