#ifndef _DRAWUPOINT_H_
#define _DRAWUPOINT_H_

#include "obj.h"

int upoint_init( unsigned int serial,
                 char *name, float lo, float la, float h_km, obj_t *parent,
                 unsigned char r,
                 unsigned char g,
                 unsigned char b );
                 
void upoint_clear( unsigned int serial );

void upoint_get_lola( obj_t *o, float *lo, float *la );
void upoint_get_height( obj_t *o, float *h_km );

void upoint_get_color( obj_t *o,
                       unsigned char *r,
                       unsigned char *g,
                       unsigned char *b );
void upoint_allclear( void);
void find_nearest_upoint_from_cursor( void);
obj_t *find_upoint_was_selected( void);
obj_t *find_upoint_from_serial( unsigned int serial);

#include "lumiproto_cli.h"

typedef struct _upoint_work_t {
    unsigned int serial;
    float longitude;
    float latitude;
    float h_km; // Height from the ground
    int hit;
    int anim_cnt;
    unsigned char r,g,b;
    float sx,sy,sz; // coordinate on the earth sphere
    LPDIRECT3DVERTEXBUFFER8 vb;
    char name[LUMIPROTO_NAME_MAX+1];
}upoint_work_t;

#endif
