#ifndef _FONT_H_
#define _FONT_H_

#include <d3d8.h>
#include <d3dx8.h>
#include "common.h"

#define FONT_MAX 500

typedef struct _font_t
{
    BOOL use;
    char str[1024];
    int x;
    int y;
    int priority;
    D3DCOLOR color;
    
}font_t;
/* structure for font cache */
typedef struct _font_cache_t
{
    LPD3DXFONT font;
    int ref_count;   /* reference counter */
}font_cache_t;

#define FONT_SIZE_X 16
#define FONT_SIZE_Y 8

void font_draw( void);
BOOL font_append( char *str, int x, int y, int priority, D3DCOLOR color);
font_t *font_get_font_empty( void);
void font_finalize( void);
BOOL font_init( void);
void font_reset( void);
void font_restore( void);

#endif
