
#include "vce.h"
#include <windows.h>
#include <stdio.h>
#include "obj.h"
#include "log.h"
#include "drawupoint.h"

int log_write( unsigned int serial, char *text)
{
    FILE *fp;
    char fn[1024];
    struct tm *tm;
    time_t t;
    upoint_work_t *uw;
    
    t = time( NULL);
    tm = localtime( &t);

    vce_snprintf( fn, sizeof( fn), "msg_%d%d%d.txt",
                  tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday);
    
    fp = fopen( fn, "a");
    if( fp == NULL) return -1;
    
    obj_t *o = find_upoint_from_serial( serial);
    fprintf( fp, "%d/%d/%d %d:%d:%d ",
             tm->tm_year + 1900, tm->tm_mon + 1, tm->tm_mday,
             tm->tm_hour, tm->tm_min, tm->tm_sec);
    fprintf( fp, "from %u ", serial);
    if( o != NULL) {
        uw = (upoint_work_t *) o->work;
        fprintf( fp, "(lo:%3.6f la:%3.6f)", uw->longitude,
                 uw->latitude);
    }
    fprintf( fp, "\n%s\n\n", text);
    fclose( fp);
    return 0;
}
