#include "vce.h"

#include <windows.h>
#include <d3d8.h>
#include <d3dx8.h>
#include "font.h"
#include "common.h"
#include "msg.h"
#include "draw.h"

static int messagenum;

static message_list_t *message_top;
static message_list_t *message_bottom;
static int message_pos_x;
static int message_pos_y;
static int message_pos_y_buttom;

int message_init( void)
{
    messagenum = 0;
    message_top = NULL;
    message_bottom = NULL;
    message_pos_x = 16;
    message_pos_y = 100;
    message_pos_y_buttom = client_area_height - 20;
    return TRUE;
}
int message_calc_displayable_line_num( void)
{
    return ( message_pos_y_buttom - message_pos_y ) / (FONT_SIZE_Y*2);
}    
void message_set_position( int x, int y, int y_buttom)
{
    message_pos_x = x;
    message_pos_y = y;
    message_pos_y_buttom = y_buttom;
}    
int message_check_overflow( int num)
{
    message_list_t *m_list;
    message_list_t *next;
    if( messagenum <= num) return FALSE;
    for( m_list = message_top; m_list != NULL && messagenum > num; m_list = next) {
        next = m_list->next;
        free( m_list);
        message_top = next;
        messagenum --;
    }
    return TRUE;
}
int message_append( char *str, int r, int g, int b)
{

    message_list_t *m_list;
    
    m_list = ( message_list_t *)malloc( sizeof( message_list_t));
    if( m_list == NULL) {
        vce_errout( "can not allocate memory\n");
        return FALSE;
    }
    strcpy( m_list->str, str);
    m_list->r = r;
    m_list->g = g;
    m_list->b = b;
    m_list->next = NULL;
    if( message_top == NULL ) {
        message_top = m_list;
        message_bottom = m_list;
    }
    else {
        message_bottom->next = m_list;
        message_bottom = m_list;
    }
    messagenum ++;
    message_check_overflow( message_calc_displayable_line_num());
    message_adjust_position();
    return TRUE;
}
void message_adjust_position( void)
{
    message_list_t *m_list;
    int cnt = 0;
    for( m_list = message_top; m_list != NULL; m_list = m_list->next) {
        m_list->x = message_pos_x;
        m_list->y = message_pos_y + cnt * (FONT_SIZE_Y *2);
        cnt ++;
    }
}
int message_reset( void)
{
    message_list_t *m_list;
    message_list_t *next;
    for( m_list = message_top; m_list != NULL; m_list = next) {
        next = m_list->next;
        free( m_list);
    }
    message_init();
	return TRUE;
}    
void message_append_to_font_all( void)
{
    message_list_t *m_list;
    message_list_t *next;
    for( m_list = message_top; m_list != NULL; m_list = next) {
        next = m_list->next;
        font_append( m_list->str, m_list->x, m_list->y, 0,
                     D3DCOLOR_XRGB( m_list->r, m_list->g, m_list->b));
    }
}
void message_restore( void)
{
    message_pos_y_buttom = client_area_height - 20;
    
}
