
#include <windows.h>

#include "parsecmd.h"
#include "main.h"

/*
 * handling parse command line arguments.
 */


/*
 * parse command line
 *
 * If filename extension of LuminouSphere is ".exe",
 * ignore some arguments, or analysis as specific LuminouSphere.( may be PENING)
 *
 * (memo)
 * specific screen saver arguments that is given from the Windows.
 *
 * [none]    - Show the Settings dialog box.
 * /c <HWND> - Show the Settings dialog box, modal to the foreground window.
 * /p <HWND> - Preview Screen Saver as child of window <HWND>.
 * /s        - Run the Screen Saver.
 * /a        - change password( win95 only)
 * /t        - test mode
 * 
 */

int screen_saver_mode;
HWND hwnd_scr_parent;

static void get_hwnd( char *arg)
{
    arg++;
    while( *arg && !isdigit( *arg)) arg++;
    if( isdigit( *arg)) {
        hwnd_scr_parent = (HWND)atol( arg);
    }
    else hwnd_scr_parent = NULL;
    
}
int parse_command_line( char *arg)
{
    char buff[1024];
    screen_saver_mode = SMODE_CONFIG;
    char ext[4];
    int len;
    hwnd_scr_parent = NULL;
    
    /* skip the first part of the command line, which is the full path
       to the exe. If it contains spaces, it will be contained in quotes. */
    if( *arg == '\"') {
        arg++;
        while( *arg != '\0' && *arg != '\"') arg++;
        if( *arg == '\"') arg++;
    }
    else {
        while( *arg != '\0' && *arg != ' ') arg++;
        if( *arg == ' ') arg++;
    }
    GetModuleFileName( NULL, buff, sizeof( buff));
    len = strlen( buff);
    if( len >= 5) {
        memset( ext, 0, sizeof( ext));
        for( int i = 0; i < 3; i ++ ) {
            ext[i] = tolower( buff[len - 3 + i]);
        }
        if( strcmp( ext, "exe") == 0 )  {
            screen_saver_mode = SMODE_NONE;
            return 0;
        }
    }
    if( screen_saver_mode) {
        while( *arg != '\0' && *arg != '/' && *arg != '-') arg++;
        if( *arg == '\0') return 0;
        switch( *(++arg)) {
        case 'c':
        case 'C':
            get_hwnd( arg);
            return 0;
        case 't':
        case 'T':
            screen_saver_mode = SMODE_TEST;
            return 0;
        case 'p':
        case 'P':
            get_hwnd( arg);
            screen_saver_mode = SMODE_PREVIEW;
            return 0;
        case 'a':
        case 'A':
            get_hwnd( arg);
            screen_saver_mode = SMODE_PASSCHANGE;
            return 0;
        default:
            screen_saver_mode = SMODE_SCR;
            return 0;
        }
    }
    return 0;
}
