
#include "vce.h"
#include <windows.h>
#include "sendmsg.h"
#include "obj.h"
#include "resource.h"
#include "main.h"
#include "win.h"
#include "net.h"
#include "msg.h"
#include "msgdlg.h"
#include "drawupoint.h"
#include "camera.h"
#include "config.h"
#include "m.h"

void sendmsg_dialog_close( HWND hwnd)
{

    DestroyWindow( hwnd);
    msgdlg_free_one( hwnd);
}
    
LRESULT CALLBACK sendmsg_dlg_proc( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
    switch( msg) {
    case WM_INITDIALOG:
        if( config.send_msgdlg_last_x.int_val != CW_USEDEFAULT &&
            config.send_msgdlg_last_y.int_val != CW_USEDEFAULT )
        {
            RECT rect;
            GetWindowRect( hwnd, &rect);
            MoveWindow( hwnd, config.send_msgdlg_last_x.int_val,
                        config.send_msgdlg_last_x.int_val,
                        rect.right - rect.left,
                        rect.bottom - rect.top, TRUE);
        }
        return FALSE;
    case WM_COMMAND:
        switch( LOWORD( wp)) {
        case IDOK:
        {
            char buff[256];
            unsigned int serial;
            GetWindowText( GetDlgItem( hwnd, IDC_EDITSENDINFO1), buff, sizeof( buff));
            serial = atoi( buff);
            if( find_upoint_from_serial( (unsigned)serial) == NULL) {
//                vce_snprintf( buff, sizeof( buff), "Not found user:%u", serial);
//                message_append( buff, 255,255,0);
            }
            else {
                GetWindowText( GetDlgItem( hwnd, IDC_EDITMSG), buff, sizeof( buff));
                net_sendmsg( serial, buff);
            }
            sendmsg_dialog_close( hwnd);
        }
        break;
        case IDCANCEL:
            sendmsg_dialog_close( hwnd);
            break;
        case IDC_FIND:
        {
            obj_t *obj;
            char buff[256];
            unsigned int serial;
            upoint_work_t *up;
            GetWindowText( GetDlgItem( hwnd, IDC_EDITSENDINFO1), buff, sizeof( buff));
            serial = atoi( buff);
            obj = find_upoint_from_serial( serial);
            if( obj == NULL) break;
            up = (upoint_work_t *)obj->work;
            camera_move_to_upoint_init( up->longitude, up->latitude);
            up->hit = 1;
            break;
        }
        }
        break;
    case WM_MOVE:
        config.send_msgdlg_last_x.int_val = LOWORD( lp);
        config.send_msgdlg_last_y.int_val = HIWORD( lp);
        break;
    case WM_CLOSE:
        sendmsg_dialog_close( hwnd);
        break;
    default:
        return FALSE;        
    }
    return TRUE;
}
/* -------------------------------------------------------------------------
 * create sendmessage dialog
 * -------------------------------------------------------------------------*/
int sendmsg_create_dialog( unsigned int serial)
{
    msg_dlg_t *s;
    obj_t *obj;
    char buff[128];
    
    s = (msg_dlg_t *)vce_alloc_array_object( msg_dlg_mi);
    if( s == NULL) return -1;
    
    s->hwnd = CreateDialog(
        hInst, MAKEINTRESOURCE( IDD_SENDMSG),
        hWnd,(DLGPROC)sendmsg_dlg_proc);
    
    obj = find_upoint_from_serial( serial);
    if( obj != NULL) {
        upoint_work_t *up;
        int h,m,sec;
        up = (upoint_work_t *)obj->work;
        vce_snprintf( buff, sizeof( buff), "%u", serial);
        SetWindowText( GetDlgItem( s->hwnd, IDC_EDITSENDINFO1), buff);
        SetWindowText( GetDlgItem( s->hwnd, IDC_EDITSENDINFO4), up->name);
        earth_conv_rad_to_hms( up->longitude, &h, &m, &sec);
        vce_snprintf( buff, sizeof( buff), "%d'%d\"%d", h,m,sec);
        SetWindowText( GetDlgItem( s->hwnd, IDC_EDITSENDINFO2), buff);
        earth_conv_rad_to_hms( up->latitude, &h, &m, &sec);
        vce_snprintf( buff, sizeof( buff), "%d'%d\"%d", h,m,sec);
        SetWindowText( GetDlgItem( s->hwnd, IDC_EDITSENDINFO3), buff);
    }
    ShowWindow( s->hwnd, SW_SHOW);
    s->serial = serial;
    return 0;
}
