#ifndef _LUMIMAIN_H_
#define _LUMIMAIN_H_

#include "vce.h"
#include "lumiproto_sv.h"

/* server configuration */
typedef struct _options_t
{
    int verbose;
    int printd_out;
    int swp_port;
    int swp_max;
    int swp_hiwater;
    int swp_rw_buf;
    int circ_max;
    int circ_hiwater;
    int circ_rw_buf;
    int client_timeout;
    int print_oneline_every;
    char errout_dir[1024];
    int admin_port;
    char announce_pass[1024];
    char namelogfile[1024];
    char statfile[1024];
}options_t;

/* server runtime statistics */
typedef struct _statistics_t
{
    double accept_count, hi_accept_count;
    double close_count;
    double login_count, login_e_count;
    double send_status_count;
    double msg_count, msg_watch_count;
    double ping_count;
    double too_long_msg_count;
    double msg_user_not_found_count, msg_user_found_count;
    double swp_accept_count;
    double admin_stats_ok;
    double login_total;
    double msg_total;
} statistics_t;

/* Content of VCE circ_t state buffer */
typedef struct _circ_opts
{
    /* user information */
    struct _user *u;
    int hiwater;
} circ_opts;


extern tcpcontext_t tcp_swp;
extern int client_timeout;
extern unsigned int current_time;

extern options_t opts;
extern statistics_t stats;

char *make_stats_text( char *out, int outlen );
void put_namelog( char *n );

#endif
    
