#ifndef _USER_H_
#define _USER_H_

#include <time.h>
#include "vce.h"

#include "lumiproto_sv.h"

typedef struct _user
{
    unsigned int serial;
    int x,y;
    char r,g,b; /* 24 bit user color */
    time_t when_allocate; /* time of allocating this user */
    time_t when_message_send; /* time of the last message-send */
    time_t when_message_recv; /* time of the last message-receipt */
    circ_t owner_circ;
    char name[LUMIPROTO_NAME_MAX+1];
} user;

extern int user_mi;


user *user_alloc( circ_t oc, char *n, int x, int y, char r, char g, char b );
int user_init( int max );
void user_free( user *u );
void notify_all_user_new_status( int x, int y, int status,
                                 char r, char g, char b);
void send_msg_user( unsigned int from_serial,
                    unsigned int to_serial, char *tex, int texlen,
                    char r, char g, char b );
void tell_user_login_to_all(user *u );
void tell_user_logout_to_all(user *u);
void user_know_who_are_online( user *u );
void send_announce_all_users( unsigned int from_serial,
                              char *msg, int msg_len,
                              char r, char g, char b );

#endif
